<?php

namespace App\Exceptions;

use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Response;
use Illuminate\Validation\UnauthorizedException;
use Symfony\Component\HttpFoundation\Exception\BadRequestException;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
use Throwable;

class Handler extends ExceptionHandler
{
    /**
     * A list of the exception types that are not reported.
     *
     * @var array<int, class-string<Throwable>>
     */
    protected $dontReport = [
        //
    ];

    /**
     * A list of the inputs that are never flashed for validation exceptions.
     *
     * @var array<int, string>
     */
    protected $dontFlash = [
        'current_password',
        'password',
        'password_confirmation',
    ];

    /**
     * Register the exception handling callbacks for the application.
     *
     * @return void
     */
    public function register()
    {
        $this->reportable(function (Throwable $e) {
            //
        });
    }

    public function render($request, Throwable $e): Response|JsonResponse|\Symfony\Component\HttpFoundation\Response
    {
        if ($e instanceof ValidationException) {
            return response()->json([
                'message' => __('response.validation'),
                'errors' => $e->getErrors()
            ], 422);
        }

        if ($e instanceof ForbiddenException) {
            return response()->json([
                'message' => __('response.forbidden'),
            ], 403);
        }

        if ($e instanceof NotFoundException) {
            return response()->json([
                'message' => __('response.not_found'),
            ], 404);
        }
        if ( $e instanceof NotFoundHttpException) {
            return response()->json([
                'message' => __('response.not_found_route'),
            ], 404);
        }

        if ( $e instanceof BadRequestException) {
            return response()->json([
                'message' => __($e->getMessage()),
            ], 400);
        }

        if ( $e instanceof UnauthorizedException) {
            return response()->json([
                'message' => __('response.unauthorized'),
            ], 401);
        }

        return parent::render($request, $e); // TODO: Change the autogenerated stub
    }
}
